/***********************************************************************NTNU IT*
* rdtsc.c - read AMD/Intel processor cycle counter
*------------------------------------------------------------------------------
* $Id: rdtsc.h 53 2009-09-10 08:43:30Z joern $
*******************************************************************************/

#ifndef RDTSC_H
#define RDTSC_H

#if defined( _MSC_VER )

#define _WIN32
#if defined( _WIN32 )

#include <intrin.h>
#pragma intrinsic( __rdtsc )
__inline volatile unsigned long long read_tsc(void)
{
	return __rdtsc();
}

#else

__inline volatile unsigned long long read_tsc(void)
{   unsigned long lo, hi;
	__asm cpuid __asm rdtsc __asm mov [lo],eax __asm mov [hi],edx ; 
	return (((unsigned long long)hi) << 32) + lo;
}

#endif

#elif defined( __GNUC__ )

__inline unsigned long long read_tsc(void)
{
#if defined(i386)
unsigned long long a;
asm volatile("rdtsc":"=A" (a));
return a;
#elif(defined __x86_64)
unsigned int _hi,_lo;
asm volatile("rdtsc":"=a"(_lo),"=d"(_hi));
return ((unsigned long long int)_hi << 32) | _lo;
#endif
}

#else
#error A high resolution timer is not available
#endif

#endif
